#include "BLEDevice.h"


#include <ESPmDNS.h>

#include "driver/gpio.h"

#define SW_Version "3.4"

bool debug_flg = true;
bool debug_flg_full_log = true;

//########### Settings beginnen #########

//BMS-BLE Settings
const char* Geraetename = "JK_B2A8S20P";  //JK-B2A24S20P JK-B2A24S15P

const byte Akkustand_gpio = 25;           // Analogausgang für Akkufüllstand

//########### Ende der "User" Settings #########


static BLEUUID serviceUUID("ffe0"); // The remote service we wish to connect to.
static BLEUUID    charUUID("ffe1"); //ffe1 // The characteristic of the remote service we are interested in.
BLEClient*  pClient;
BLEScan* pBLEScan;
byte getdeviceInfo[20] = {0xaa, 0x55, 0x90, 0xeb, 0x97, 0x00, 0xdf, 0x52, 0x88, 0x67, 0x9d, 0x0a, 0x09, 0x6b, 0x9a, 0xf6, 0x70, 0x9a, 0x17, 0xfd}; // Device Infos
//byte getInfo[20] = {0xaa, 0x55, 0x90, 0xeb, 0x96, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10}; 
byte getInfo[20] = {0xaa, 0x55, 0x90, 0xeb, 0x96, 0x00, 0x79, 0x62, 0x96, 0xed, 0xe3, 0xd0, 0x82, 0xa1, 0x9b, 0x5b, 0x3c, 0x9c, 0x4b, 0x5d}; 
//byte balancer_an[20] = {0xaa, 0x55, 0x90, 0xeb, 0x1f, 0x04, 0x01, 0x00, 0x00, 0x00, 0xd3, 0x27, 0x86, 0x3b, 0xe2, 0x12, 0x4d, 0xb0, 0xb6, 0x00};

unsigned long sendingtime = 0;
unsigned long bleScantime = 0;
unsigned long mqttpublishtime = 0;
unsigned long canpublishtime = 0;
unsigned long newdatalasttime = 0;
unsigned long ble_connection_time = 0;

byte receivedBytes_main[320];
int frame = 0;
bool received_start = false;
bool received_start_frame = false;
bool received_complete = false;
bool new_data = false;
byte BLE_Scan_counter = 0;

//BMS Werte
float cellVoltage[16] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
float Average_Cell_Voltage = 0;
float Delta_Cell_Voltage = 0;
float Current_Balancer = 0;
float Battery_Voltage = 0;
float Battery_Power = 0;
float Charge_Current = 0;
float Battery_T1 = 0;
float Battery_T2 = 0;

float MOS_Temp = 0;
int Percent_Remain = 0;
float Capacity_Remain = 0;
float Nominal_Capacity = 0;
String Cycle_Count = "";
float Capacity_Cycle = 0;
uint32_t Uptime;
uint8_t sec, mi, hr, days;
float Balance_Curr = 0;
String charge = "off";
String discharge = "off";

static bool doConnect = false;
static bool ble_connected = false;
static BLERemoteCharacteristic* pRemoteCharacteristic;
static BLEAdvertisedDevice* myDevice;








static void notifyCallback(BLERemoteCharacteristic* pBLERemoteCharacteristic, uint8_t* pData, size_t length, bool isNotify) {

if(debug_flg_full_log) {
    Serial.print("Notify callback for characteristic ");
    Serial.print(pBLERemoteCharacteristic->getUUID().toString().c_str());
    Serial.print(" of data length ");
    Serial.println(length);
    Serial.print("data: ");
    for (int i = 0; i < length; i++)  {
      Serial.print(pData[i],HEX);
      Serial.print(", ");
    }
    Serial.println("");
}
    if(pData[0] == 0x55 && pData[1] == 0xAA && pData[2] == 0xEB && pData[3] == 0x90 && pData[4] == 0x02) {
      Serial.println("Daten anerkannt !");
      received_start = true;
      received_start_frame = true;
      received_complete = false;
      frame = 0;
      for (int i = 0; i < length; i++)  {
       receivedBytes_main[frame] = pData[i];
       frame++;
      }
    }

    if(received_start && !received_start_frame && !received_complete) {
//     Serial.println("Daten erweitert !");
      for (int i = 0; i < length; i++)  {
        receivedBytes_main[frame] = pData[i];
        frame++;
      }
    
      if(frame == 300) {
        Serial.println("New Data for Analyse Complete...");
        received_complete = true;
        received_start = false;
        new_data = true;
        BLE_Scan_counter = 0;    
      }
      if((frame > 300)) {
        
        Serial.println("Fehlerhafte Daten !!");     
        frame = 0;
        received_start = false;
        new_data = false;    
      }
      
    }
    //Serial.print("frame: ");
    //Serial.println(frame);   
    received_start_frame = false;

}

class MyClientCallback : public BLEClientCallbacks {
    
  void onConnect(BLEClient* pclient) {
    //client.publish("BMS_Watchdog/BLEconnection","connected");
  }

  void onDisconnect(BLEClient* pclient) {
   ble_connected = false;
   //pclient->disconnect(); 
   Serial.println("BLE-Disconnect");
   Serial.println("BLE was Disconnected ... and no BLE reconnection possible, Reboot ESP...");
   ESP.restart();
  }
};


/**
 * Scan for BLE servers and find the first one that advertises the service we are looking for.
 */
class MyAdvertisedDeviceCallbacks: public BLEAdvertisedDeviceCallbacks {
 /**
   * Called for each advertising BLE server.
   */
  void onResult(BLEAdvertisedDevice advertisedDevice) {
    Serial.print("BLE Advertised Device found: ");
    Serial.println(advertisedDevice.toString().c_str());

    // We have found a device, let us now see if it contains the service we are looking for.
    if (advertisedDevice.haveServiceUUID() && advertisedDevice.isAdvertisingService(serviceUUID) && advertisedDevice.getName() == Geraetename) {

      pBLEScan->stop();
      myDevice = new BLEAdvertisedDevice(advertisedDevice);
      doConnect = true;
      pBLEScan->clearResults(); 
      
    } // Found our server
  } // onResult
}; // MyAdvertisedDeviceCallbacks



void setup() {
  Serial.begin(115200);
  Serial.print("BMS Watchdog V ");
  Serial.println(SW_Version);
  Serial.println("Booting");

  ledcAttachPin(Akkustand_gpio, 0);   //Konfiguration das Analogausgangs
  ledcSetup(0, 4000, 8);              //Konfiguration das Analogausgangs
  
  //BLE Setup
  BLEDevice::init("");
  pClient = BLEDevice::createClient();
  Serial.println(" - Created client");

  pBLEScan = BLEDevice::getScan();
  pBLEScan->setAdvertisedDeviceCallbacks(new MyAdvertisedDeviceCallbacks());
  pBLEScan->setInterval(1349);
  pBLEScan->setWindow(449);
  pBLEScan->setActiveScan(true);


} // End of setup.


void loop() {
 
//BLE 
  if (doConnect == true) {
   if(!connectToBLEServer()) {
    Serial.println("We have failed to connect to the server; there is nothin more we will do.");
    delay(500);
    ble_connected = false;
    doConnect = false;
   }
  } 
  
  if (ble_connected) {

   if(received_complete) {
//      for (int i = 0; i < 319; i++)  {
//        Serial.print(receivedBytes_main[i],HEX);
//       Serial.print(", ");
//      }
//      Serial.println("");
     if(new_data) {
      Datenanalyse();
      newdatalasttime = millis();
     }
  
   
 }

   // BLE Get Device Data Trigger ...
   if(((millis() - sendingtime) > 500) && sendingtime != 0) { // millis() >  sendingtime + sendingtimer aktive_sending && 
      sendingtime = 0;
      Serial.println("gesendet!");
      //aktive_sending = false;
      pRemoteCharacteristic->writeValue(getInfo, 20);
   }
  
  
  
  }

  //BLE nicht verbunden 
  if((!ble_connected && !doConnect && (millis() - bleScantime) > 15000)) {

    Serial.println("BLE -> Reconnecting!");
   
    bleScantime = millis();
    pBLEScan->start(5, false);
    BLE_Scan_counter++;
  }  

  // BLE verbidnugn ist da aber es kommen seit X Sekunden keine neuen Daten !
  if(!doConnect && ble_connected && (millis() >= (newdatalasttime + 60000)) && newdatalasttime != 0){
   ble_connected = false;
   delay(200);
   
   Serial.println("BLE-Disconnect/terminated");
   newdatalasttime = millis();
   pClient->disconnect();
  }

  //checker das nach max 5 Minuten und keiner BLE Verbidung neu gestartet wird...
  if(BLE_Scan_counter > 20) {
   
   Serial.println("BLE isn´t receiving new Data form BMS... and no BLE reconnection possible, Reboot ESP...");
   ESP.restart();
   
 }
 
 ledcWrite(0, Percent_Remain*2.55);         //Ausgabe des Digitalwerts an den Analogausgang
 

} // End of loop
